<?php
require_once('./lib/0.6.8/1.76/nusoap.php');

//$debug = 1;
$server = new soap_server();
$server->soap_defencoding = 'ISO-8859-1';

$serviceName = 'phpugSample4';
$targetNameSpace = 'http://webservice.teserco.de/phpug/';
$endPoint = 'http://localhost/websites/phpug/samples/04_server_sample.php';
$bindingStyle = 'rpc';  /* rpc|document */
$bindingTransport = 'http://schemas.xmlsoap.org/soap/http';

$server->configureWSDL($serviceName, $targetNameSpace, $endPoint, $bindingStyle, $bindingTransport);
/* Namespace fr Schemadefintion bei komplexen Datentypen */
$server->wsdl->schemaTargetNamespace = 'http://webservice.teserco.de/phpug';

$server->wsdl->addComplexType(
	'ArrayOfstring',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:string[]')),
	'xsd:string'
);

$server->wsdl->addComplexType(
	'ArrayOfint',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:int[]')),
	'xsd:int'
);

$server->wsdl->addComplexType(
	'ArrayOffloat',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:float[]')),
	'xsd:float'
);

$server->wsdl->addComplexType(
	'ArrayOfdouble',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:double[]')),
	'xsd:double'
);

$server->wsdl->addComplexType(
	'ArrayOfdecimal',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:decimal[]')),
	'xsd:decimal'
);

$server->wsdl->addComplexType(
	'ArrayOfdatetime',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:dateTime[]')),
	'xsd:dateTime'
);

$server->wsdl->addComplexType(
	'ArrayOfboolean',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:boolean[]')),
	'xsd:boolean'
);

$server->wsdl->addComplexType(
	'SOAPStruct',
	'complexType',
	'struct',
	'all',
	'',
	array(
		'varString' => array('name'=>'varString','type'=>'xsd:string'),
		'varInt' => array('name'=>'varInt','type'=>'xsd:int'),
		'varFloat' => array('name'=>'varFloat','type'=>'xsd:float'),
		'varDouble' => array('name'=>'varDouble','type'=>'xsd:double'),
		'varBoolean' => array('name'=>'varBoolean','type'=>'xsd:boolean'),
		'varDate' => array('name'=>'varDate','type'=>'xsd:dateTime'),
		'varbase64' => array('name'=>'varbase64','type'=>'xsd:base64Binary')
	)
);

$server->wsdl->addComplexType(
	'ArrayOfSOAPStruct',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:SOAPStruct[]')),
	'tns:SOAPStruct'
);

$operationNameSpace = 'http://webservice.teserco.de/phpug/';
$soapAction = 'http://localhost/websites/phpug/samples/HelloWorld';
$soapActionStyle = 'rpc';                                   /* rpc|literal */
$soapActionUse = 'encoded';                                /* encoded|literal */
$documentation = 'HelloWorld Documentation';

$methodName = 'HelloWorld';
$inParam = array('income'=>'xsd:string');
$outParam = array('return'=>'xsd:string');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function HelloWorld($income){
	$output = $income. " World";
	return new soapval('output','xsd:string',$output);
}

$methodName = 'echoInEmptyOutEmpty';
$inParam = array();
$outParam = array();
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoInEmptyOutEmpty(){
    return;
}

$methodName = 'echoInEmptyOutString';
$inParam = array();
$outParam = array('return'=>'xsd:string');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoInEmptyOutString(){
	return new soapval('output','xsd:string','Hello World');
}

$methodName = 'echoString';
$inParam = array('inputString'=>'xsd:string');
$outParam = array('return'=>'xsd:string');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoString($inputString){
	return new soapval('output','xsd:string',$inputString);
}

$methodName = 'echoInteger';
$inParam = array('inputInteger'=>'xsd:int');
$outParam = array('outputInteger'=>'xsd:int');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoInteger($inputInteger){
	return $inputInteger;
}
$methodName = 'echoFloat';
$inParam = array('inputFloat'=>'xsd:float');
$outParam =	array('return'=>'xsd:float');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoFloat($inputFloat){
	return $inputFloat;
}

$methodName = 'echoDouble';
$inParam = array('inputDouble'=>'xsd:double');
$outParam = array('return'=>'xsd:double');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoDouble($inputDouble){
	return $inputDouble;
}

$methodName = 'echoBase64';
$inParam = array('inputBase64'=>'xsd:base64Binary');
$outParam = array('return'=>'xsd:base64Binary');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoBase64($b_encoded){
	return base64_encode($b_encoded);
}

$methodName = 'echoDate';
$inParam = array('inputDate'=>'xsd:dateTime');
$outParam = array('return'=>'xsd:dateTime');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoDate($timeInstant){
	return $timeInstant;
}

$methodName = 'echoDecimal';
$inParam = array('inputDecimal'=>'xsd:decimal');
$outParam = array('return'=>'xsd:decimal');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoDecimal($dec){
	return $dec;
}

$methodName = 'echoBoolean';
$inParam = array('inputBoolean'=>'xsd:boolean');
$outParam = array('return'=>'xsd:boolean');
$server->register($methodName, $inParam, $outParam, $operationNameSpace, $soapAction, $soapActionStyle, $soapActionUse, $documentation);
function echoBoolean($b){
    //Behandlung als string notwendig !!!
    if($b == "true") return true;
    else return false;
}

$server->register('echoStringArray',
	array('inputStringArray'=>'tns:ArrayOfstring'),
	array('return'=>'tns:ArrayOfstring'),
	'http://soapinterop.org/');
function echoStringArray($inputStringArray){
	return $inputStringArray;
}

$server->register('echoIntegerArray',
	array('inputIntegerArray'=>'tns:ArrayOfint'),
	array('return'=>'tns:ArrayOfint'),
	'http://soapinterop.org/');
function echoIntegerArray($inputIntegerArray){
	//return $inputIntegerArray;
	return new soapval('output','tns:ArrayOfint',$inputIntegerArray);
}

$server->register('echoFloatArray',
	array('inputFloatArray'=>'tns:ArrayOffloat'),
	array('return'=>'tns:ArrayOffloat'),
	'http://soapinterop.org/');
function echoFloatArray($inputFloatArray){
	return $inputFloatArray;
}

$server->register('echoDoubleArray',
	array('inputDoubleArray'=>'tns:ArrayOfdouble'),
	array('return'=>'tns:ArrayOfdouble'),
	'http://soapinterop.org/');
function echoDoubleArray($inputDoubleArray){
	return $inputDoubleArray;
}

$server->register('echoDecimalArray',
	array('inputDecimalArray'=>'tns:ArrayOfdecimal'),
	array('return'=>'tns:ArrayOfdecimal'),
	'http://soapinterop.org/');
function echoDecimalArray($inputDecimalArray){
	return $inputDecimalArray;
}

$server->register('echoDateTimeArray',
	array('inputDateTimeArray'=>'tns:ArrayOfdatetime'),
	array('return'=>'tns:ArrayOfdatetime'),
	'http://soapinterop.org/');
function echoDateTimeArray($inputDateTimeArray){
	return $inputDateTimeArray;
}

$server->register('echoBooleanArray',
	array('inputBooleanArray'=>'tns:ArrayOfboolean'),
	array('return'=>'tns:ArrayOfboolean'),
	'http://soapinterop.org/');
function echoBooleanArray($inputBooleanArray){
    $output = array();
    for($i=0; $i<count($inputBooleanArray); $i++){
        if($inputBooleanArray[$i] == "true")
            $output[] = true;
        else
            $output[] = false;
    }
	return $output;
}

$server->register('echoStruct',
	array('inputStruct'=>'tns:SOAPStruct'),
	array('return'=>'tns:SOAPStruct'),
	'http://soapinterop.org/');
function echoStruct($inputStruct){
    $output["varString"] = $inputStruct["varString"];
    $output["varInt"] = $inputStruct["varInt"];
    $output["varFloat"] = $inputStruct["varFloat"];
    $output["varDouble"] = $inputStruct["varDouble"];
    $output["varDate"] = $inputStruct["varDate"];
    $output["varBoolean"] = $inputStruct["varBoolean"];
    $output["varbase64"] = base64_encode($inputStruct["varbase64"]);
    
    return $output;
}

$server->register('echoStructArray',
	array('inputStructArray'=>'tns:ArrayOfSOAPStruct'),
	array('return'=>'tns:ArrayOfSOAPStruct'),
	'http://soapinterop.org/');
function echoStructArray($inputStructArray){
	for($i=0;$i<count($inputStructArray);$i++){
    	$outputStructArray[$i]["varString"] = $inputStructArray[$i]["varString"];
        $outputStructArray[$i]["varInt"] = $inputStructArray[$i]["varInt"];
        $outputStructArray[$i]["varFloat"] = $inputStructArray[$i]["varFloat"];
        $outputStructArray[$i]["varDouble"] = $inputStructArray[$i]["varDouble"];
        $outputStructArray[$i]["varDate"] = $inputStructArray[$i]["varDate"];
        $outputStructArray[$i]["varBoolean"] = $inputStructArray[$i]["varBoolean"];
        $outputStructArray[$i]["varbase64"] = base64_encode($inputStructArray[$i]["varbase64"]);
    }
    return $outputStructArray;
}

$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);
?>
