using System;
using webservice.teserco.de;

namespace webservice.teserco.de
{
	class dotnetpro
	{
		static void Main(string[] args)
		{
			Conversion convert = new Conversion();
			phpugSample4 dtpTest = new phpugSample4();
			dtpTest.RequestEncoding = System.Text.Encoding.GetEncoding("ISO-8859-1");
			dtpTest.Url = "http://localhost:8080/websites/phpug/samples/04_server_sample.php";
			
			try
			{
				myDataType mDT = new myDataType(10);
				
				Console.WriteLine(dtpTest.HelloWorld("Hello"));
				dtpTest.echoInEmptyOutEmpty();
				Console.WriteLine(dtpTest.echoInEmptyOutString());
				Console.WriteLine(dtpTest.echoString(mDT.stringArray[0]));
				Console.WriteLine(dtpTest.echoInteger(mDT.integerArray[1]).ToString());
				Console.WriteLine(dtpTest.echoFloat(mDT.floatArray[1]).ToString());
				Console.WriteLine(dtpTest.echoDouble(mDT.doubleArray[1]).ToString());
				Console.WriteLine(dtpTest.echoDecimal(mDT.decimalArray[1]).ToString());
				Console.WriteLine(dtpTest.echoDate(mDT.dateTimeArray[0]).ToString());
				Console.WriteLine(dtpTest.echoBoolean(true).ToString());
				Console.WriteLine(convert.ByteArrayToString(dtpTest.echoBase64(mDT.byteArray)));

				string[] stringArrayResult = dtpTest.echoStringArray(mDT.stringArray);
				for(int j=0; j<stringArrayResult.Length; j++) Console.Write(stringArrayResult[j]+" ");
				Console.WriteLine("\n\n");
				int[] integerArrayResult = dtpTest.echoIntegerArray(mDT.integerArray);
				for(int j=0; j<integerArrayResult.Length; j++) Console.Write(integerArrayResult[j].ToString() + " ");
				Console.WriteLine("\n\n");
				float[] floatArrayResult = dtpTest.echoFloatArray(mDT.floatArray);
				for(int j=0; j<floatArrayResult.Length; j++) Console.Write(floatArrayResult[j].ToString() + " ");
				Console.WriteLine("\n\n");
				double[] doubleArrayResult = dtpTest.echoDoubleArray(mDT.doubleArray);
				for(int j=0; j<doubleArrayResult.Length; j++) Console.Write(doubleArrayResult[j].ToString() + " ");
				Console.WriteLine("\n\n");
				decimal[] decimalArrayResult = dtpTest.echoDecimalArray(mDT.decimalArray);
				for(int j=0; j<decimalArrayResult.Length; j++) Console.Write(decimalArrayResult[j].ToString() + " ");
				Console.WriteLine("\n\n");
				DateTime[] dateTimeArrayResult = dtpTest.echoDateTimeArray(mDT.dateTimeArray);
				for(int j=0; j<dateTimeArrayResult.Length; j++) Console.Write(dateTimeArrayResult[j].ToString() + " ");
				Console.WriteLine("\n\n");
				bool[] booleanArrayResult = dtpTest.echoBooleanArray(mDT.booleanArray);
				for(int j=0; j<booleanArrayResult.Length; j++) Console.Write(booleanArrayResult[j].ToString() + " ");
				Console.WriteLine("\n\n");
			
				SOAPStruct soapStructResult = dtpTest.echoStruct(mDT.soapStruct0[1]);
				Console.WriteLine(soapStructResult.varString + " " +
					soapStructResult.varInt.ToString() + " " +
					soapStructResult.varFloat.ToString() + " " +
					soapStructResult.varDouble.ToString() + " " +
					soapStructResult.varDate.ToString() + " " +
					soapStructResult.varBoolean.ToString() + " " +
					convert.ByteArrayToString(soapStructResult.varbase64));
				Console.WriteLine("\n\n");

				SOAPStruct[] soapStructArrayResult = dtpTest.echoStructArray(mDT.soapStruct0);
				for(int j=0; j<soapStructArrayResult.Length; j++) 
					Console.WriteLine(soapStructArrayResult[j].varString + " " +
						soapStructArrayResult[j].varInt.ToString() + " " +
						soapStructArrayResult[j].varFloat.ToString() + " " +
						soapStructArrayResult[j].varDouble.ToString() + " " +
						soapStructArrayResult[j].varDate.ToString() + " " +
						soapStructArrayResult[j].varBoolean.ToString() + " " +
						convert.ByteArrayToString(soapStructArrayResult[j].varbase64));
				Console.WriteLine("\n\n");

			}
			catch(System.Net.WebException e)
			{
				Console.WriteLine(e.Message);
			}
			finally
			{
				Console.ReadLine();
			}
		}
	}

	#region myDataType
	class myDataType
	{
		public int[] integerArray;
		public float[] floatArray;
		public string[] stringArray;
		public double[] doubleArray;
		public decimal[] decimalArray;
		public byte[] byteArray;
		public DateTime[] dateTimeArray;
		public bool[] booleanArray;
		public SOAPStruct[] soapStruct0;
		//public TESTStruct[] testStruct0;

		public myDataType(int dimension)
		{
			Conversion convert = new Conversion();

			integerArray = new int[dimension];
			floatArray = new float[dimension];
			stringArray = new string[dimension];
			doubleArray = new double[dimension];
			decimalArray = new decimal[dimension];
			dateTimeArray = new DateTime[dimension];
			booleanArray = new bool[dimension];

			for(int j=0;j<dimension;j++)
			{
				//Fill integerArray
				integerArray[j] = j;
				//Fill floatArray
				floatArray[j] = Convert.ToSingle(j * 1.347892347765327652167);
				//Fill doubleArray
				doubleArray[j] = Convert.ToDouble(j * 1.347892347765327652167f);
				//Fill stringArray
				stringArray[j] = "Das ist String Nr. " + j.ToString() + " mit  <&amp; \'\">";

				decimalArray[j] = Convert.ToDecimal(j * 1.347892347765327652167m);

				dateTimeArray[j] = new DateTime(2003 + j,7,15,17,3,59);

				if((j % 2) > 0)
					booleanArray[j] = true;
				else
					booleanArray[j] = false;
			}
			byteArray = convert.StringToByteArray("Das ist ein String mit  <&amp; \'\">");


			soapStruct0 = new SOAPStruct[dimension];

			for(int j=0;j<dimension;j++)
			{
				//Fill soapStructArray
				soapStruct0[j] = new SOAPStruct();
				soapStruct0[j].varString = this.stringArray[j];
				soapStruct0[j].varInt = this.integerArray[j];
				soapStruct0[j].varFloat = this.floatArray[j];				
				soapStruct0[j].varDouble = this.doubleArray[j];
				soapStruct0[j].varDate = this.dateTimeArray[j];
				soapStruct0[j].varBoolean = this.booleanArray[j];
				soapStruct0[j].varbase64 = this.byteArray;
			}
			/*
			testStruct0 = new TESTStruct[dimension];

			for(int j=0;j<dimension;j++)
			{
				//Fill soapStructArray
				testStruct0[j] = new TESTStruct();
				testStruct0[j].testString = this.stringArray[j];
				testStruct0[j].testInt = this.integerArray[j];
				testStruct0[j].testFloat = this.floatArray[j];				
			}
			*/
		}
	}
	#endregion

	#region Conversion
	public class Conversion
	{
		public byte[] StringToByteArray (string InputString)
		{
			char[] buffer = InputString.ToCharArray();
			int length = buffer.Length;
			byte[] result = new Byte[length];
			for(int i=0; i<length; i++)
			{
				result[i] = Convert.ToByte(buffer[i]);
			}
			return result;
		}

		public string ByteArrayToString (byte[] InputArray)
		{
			int length = InputArray.Length;
			string result = string.Empty;
			for(int i=0; i<length; i++)
			{
				result += Convert.ToChar(InputArray[i]);
			}
			return result;
		}
	}
	#endregion
}
