<?php
/* RPC/ENCODED */
require_once('../../lib/0.6.8/1.76/nusoap.php');

$myMISC = new MISC();

echo "<b>REMOTE PROCEDURE CALLS</b><br><br>";
$client = new soapclient('http://localhost/websites/phpug/samples/09_server_sample.asmx?WSDL',true);

$client->soap_defencoding = 'ISO-8859-1';

$proxy = $client->getProxy();

echo "<b>[HelloWorld - no input]</b><br>";
$output = $client->call('HelloWorld', array());
echo "in []: - out [string]: " . $output;
echo "<br><br>";

echo "<b>[no input -> string]</b><br>";
$output = $client->call('TestRpc1', array());
echo "in []: - out [string]: " . $output . "<br><br>";

echo "<b>[string -> string]</b><br>";
$output = $client->call('TestRpc2', array('input'=>$myMISC->param1));
echo "in [string]: " . $myMISC->param1 . " - out [string]: " . $output . "<br><br>";

echo "<b>[integer -> integer]</b><br>";
$output = $client->call('TestRpc14', array($myMISC->param2));
echo "in [integer]: " . $myMISC->param2 . " - out [integer]: " . $output . "<br><br>";

echo "<b>[float -> float]</b><br>";
$output = $client->call('TestRpc10', array($myMISC->param3));
echo "in [float]: " . $myMISC->param3 . " - out [float]: " . $output . "<br><br>";

echo "<b>[boolean -> boolean]</b><br>";
$output = $client->call('TestRpc11', array($myMISC->param4));
echo "in [boolean]: " . (string)$myMISC->param4 . " - out [boolean]: " . $output . "<br><br>";

echo "<b>[base64Binary -> base64Binary]</b><br>";
$output = $client->call('TestRpc12', array($myMISC->param6));
echo "in [base64Binary]: " . $myMISC->param6 . " - out [base64Binary]: " . $output . "<br><br>";

echo "<b>[dateTime -> dateTime]</b><br>";
$output = $client->call('TestRpc13', array($myMISC->param7));
echo "in [dateTime]: " . $myMISC->param7 . " - out [dateTime]: " . $output . "<br><br>";

echo "<b>[floatArray -> floatArray]</b><br>";
$input = array(5.67,345.897,536.8);
$output = $client->call('TestRpc16', array($input));
$myMISC->displayStringArray($input, $output);
echo "<br>";

echo "<b>[no input -> stringArray]</b><br>";
$output = $client->call('TestRpc31', array());
$myMISC->displayStringArray(null, $output);
echo "<br>";

echo "<b>[stringArray -> stringArray]</b><br>";
$output = $client->call('TestRpc3', array($myMISC->stringArray));
$myMISC->displayStringArray($myMISC->stringArray, $output);
echo "<br>";

echo "<b>[soapStruct -> soapStruct]</b><br>";
$output = $client->call('TestRpc4', array($myMISC->inputStruct));
$myMISC->displayResult($myMISC->inputStruct, $output);
echo "<br>";

echo "<b>[soapStructArray -> soapStructArray]</b><br>";
$output = $client->call('TestRpc5', array($myMISC->inputStructArray));
$myMISC->displayResultArray($myMISC->inputStructArray, $output);
echo "<br>";

class MISC{
    var $param1;
    var $param2;
    var $param3;
    var $param4;
    var $param5;
    var $param6;
    var $param7;
    var $stringArray;
    var $inputStruct;
	var $inputStructArray;
    
    function MISC(){

        $this->param1 = 'Text ';
        $this->param2 = 5;
        $this->param3 = 3.144355465865457542772753454364363634;
        $this->param4 = true;
        $this->param5 = false;
        $this->param6 = base64_encode('Text ');
        $this->param7 = $this->actual_datetime_xml();
        
        $this->base64EncodeArray = array(
					$this->param6,
					$this->param6,
					$this->param6
		);
        
        $this->stringArray = array(
					$this->param1 . "- Text",
					$this->param1 . "- Text",
					$this->param1 . "- Text"
		);
		
		$this->inputStruct = array(
                    'param1' => $this->param1,
                    'param2' => $this->param2,
                    'param3' => $this->param3
        );
		
		$this->inputStructArray = array();
		$this->inputStructArray[0] = $this->inputStruct;
		$this->inputStructArray[1] = $this->inputStruct;
		$this->inputStructArray[2] = $this->inputStruct;
    }

    function displayStringArray($in, $out){
        for($i=0; $i<count($out); $i++){
            echo "in [string]: " . $in[$i] . " - out [string]: " . $out[$i] . "<br>";
        }
    }

    function displayBase64EncodedArray($in, $out){
        for($i=0; $i<count($in); $i++){
            echo "in [string]: " . $in[$i] . " - out [string]: " . base64_decode($out[$i]) . "<br>";
        }
    }
    
    function displayResult($in, $out){
        echo "in [string]: " . $in["param1"] . " - out [string]: " . $out["param1"] . "<br>";
        echo "in [integer]: " . $in["param2"] . " - out [integer]: " . $out["param2"] . "<br>";
        echo "in [float]: " . $in["param3"] . " - out [float]: " . $out["param3"] . "<br>";
    }
    
    function displayResultArray($in, $out){
        for($i=0; $i<count($out); $i++){
            $this->displayResult($in[$i], $out[$i]);
        }
    }
    
    function actual_datetime_xml() {
	    //2003-07-15T17:03:59.0000000+02:00
		$curdate = getdate ();
		$output = date("Y-m-d", mktime($curdate["hours"], $curdate["minutes"], $curdate["seconds"], $curdate["mon"], $curdate["mday"], $curdate["year"]));
		$output .= "T";
        $output .= date("H:i:s", mktime($curdate["hours"], $curdate["minutes"], $curdate["seconds"], $curdate["mon"], $curdate["mday"], $curdate["year"]));
        $output .= ".0000000";
        $output .= "";
	    return $output;
	}
}
?>
